package sam.gui.edit ;     

import java.awt.* ; 
import java.awt.event.* ;      
import java.util.* ;
import java.io.* ;
import javax.swing.* ; 
import javax.swing.border.* ; 
import javax.swing.event.* ; 

/**
  *  SymbolChooser
  *     Widget containing buttons labelled 
  *       with math/logic symbols (from file).
  *     When a button is pushed, the symbol inserts
  *        at the cursor for the autolog editor.
  *  @author &copy; John R. Fisher
  *  @version 4/9/2021
  *  john.r.fisher@protonmail.com
   */
public class SymbolChooser extends JFrame {  
   private File symbolFile ;
   private String name ;
   private JPanel panel ;
   private AutoLogEditor editor ; 
   private Vector<String> symbolList ;

   protected SymbolChooser(File f, String name, 
                           int width, int height, 
                           AutoLogEditor editor) {
      this.symbolFile = f ;
      this.name = name ;      
      this.panel = new JPanel() ;
      this.editor = editor ; 
   }



} // end SymbolChooser 

/* 
AutologEditor code for "symbols"

      else if (command.equals("symbols")) {  
         // INFOFRAME
         try { 
            Class clz = activatorFor.getClass() ; 
            URL symbols = clz.getResource("symbols.txt") ;
            JEditorPane infoPane = 
               new JEditorPane(symbols) ; 
            infoPane.setBackground(backgroundColor) ; 
            infoPane.setFont(new Font("monospaced",Font.PLAIN,24)) ;
            infoPane.setBorder(BorderFactory.createMatteBorder(8,8,0,3,Color.GRAY));
            JScrollPane scroller = new JScrollPane(infoPane) ; 
            JFrame infoFrame = new JFrame() ; 
            infoFrame.setTitle("Unicode Symbol Tables") ; 
            infoFrame.getContentPane().add(scroller) ; 
            infoFrame.setDefaultCloseOperation(WindowConstants.DISPOSE_ON_CLOSE) ; 
            infoFrame.setSize(620,650) ;   // 600,650
            infoFrame.setVisible(true) ;                
         } catch (Exception xx) { System.out.println(xx) ; } 

      }

/////////////////////////////////////////////////////////////////
///// Toolbar ///////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////
      toolbar = new JToolBar() ; 
      toolbar.setBackground(shadeColor) ; 
      Class cls = this.getClass() ; 
      Font bfont = new Font("monospaced",Font.PLAIN,18) ;

      JButton saveButton = new JButton("Save") ; 
      saveButton.setFont(bfont) ;
      saveButton.createToolTip() ; 
      saveButton.setToolTipText("<html><font size=\"+2\">save to file") ; 
      saveButton.setBackground(shadeColor) ; 
      saveButton.addActionListener(fileActivator) ; 
      saveButton.setActionCommand("save") ;
      toolbar.add(saveButton) ; 
      //toolbar.add(new JToolBar.Separator()) ;       

      compileButton = new JButton("Compile") ; 
      compileButton.setFont(bfont) ;
      compileButton.createToolTip() ; 
      compileButton.setToolTipText("<html><font size=\"+2\">compile to AutoLogViewer") ; 
      compileButton.setBackground(shadeColor) ; 
      compileButton.addActionListener(commandActivator) ; 
      compileButton.setActionCommand("compile") ;
      toolbar.add(compileButton) ; 
      toolbar.add(new JLabel("   ")) ;       
      circleButton = new JButton("∘") ; 
      circleButton.setFont(bfont) ;  
      circleButton.createToolTip() ; 
      circleButton.setToolTipText("<html><font size=\"+2\">insert ∘ (composition) at cursor") ; 
      circleButton.setBackground(shadeColor) ; 
      circleButton.addActionListener(commandActivator) ; 
      circleButton.setActionCommand("circle") ;
      toolbar.add(circleButton) ; 
      /////
      ccircleButton = new JButton("∙") ; 
      ccircleButton.setFont(bfont) ;  
      ccircleButton.createToolTip() ; 
      ccircleButton.setToolTipText("<html><font size=\"+2\">insert ∙ (product) at cursor") ; 
      ccircleButton.setBackground(shadeColor) ; 
      ccircleButton.addActionListener(commandActivator) ; 
      ccircleButton.setActionCommand("ccircle") ;
      toolbar.add(ccircleButton) ; 

      toolbar.add(new JLabel("   ")) ;       

      //toolbar.add(new JToolBar.Separator()) ;       
      meetButton = new JButton("∧") ; 
      meetButton.setFont(bfont) ;  
      meetButton.createToolTip() ; 
      meetButton.setToolTipText("<html><font size=\"+2\">insert ∧ (meet) at cursor") ; 
      meetButton.setBackground(shadeColor) ; 
      meetButton.addActionListener(commandActivator) ; 
      meetButton.setActionCommand("meet") ;
      toolbar.add(meetButton) ; 
      /////
      joinButton = new JButton("∨") ; 
      joinButton.setFont(bfont) ;  
      joinButton.createToolTip() ; 
      joinButton.setToolTipText("<html><font size=\"+2\">insert ∨ (join) at cursor") ; 
      joinButton.setBackground(shadeColor) ; 
      joinButton.addActionListener(commandActivator) ; 
      joinButton.setActionCommand("join") ;
      toolbar.add(joinButton) ; 
      /////
      notButton = new JButton("¬") ; 
      notButton.setFont(bfont) ;  
      notButton.createToolTip() ; 
      notButton.setToolTipText("<html><font size=\"+2\">insert ¬ (not) at cursor") ; 
      notButton.setBackground(shadeColor) ; 
      notButton.addActionListener(commandActivator) ; 
      notButton.setActionCommand("not") ;
      toolbar.add(notButton) ; 
      /////
      ifButton = new JButton("→") ; 
      ifButton.setFont(bfont) ;  
      ifButton.createToolTip() ; 
      ifButton.setToolTipText("<html><font size=\"+2\">insert → (imply >) at cursor") ; 
      ifButton.setBackground(shadeColor) ; 
      ifButton.addActionListener(commandActivator) ; 
      ifButton.setActionCommand("if") ;
      toolbar.add(ifButton) ; 
      /////
      fiButton = new JButton("←") ; 
      fiButton.setFont(bfont) ;  
      fiButton.createToolTip() ; 
      fiButton.setToolTipText("<html><font size=\"+2\">insert ← (&lt; < imply) at cursor") ; 
      fiButton.setBackground(shadeColor) ; 
      fiButton.addActionListener(commandActivator) ; 
      fiButton.setActionCommand("fi") ;
      toolbar.add(fiButton) ; 
      /////
      iffButton = new JButton("↔") ; 
      iffButton.setFont(bfont) ;  
      iffButton.createToolTip() ; 
      iffButton.setToolTipText("<html><font size=\"+2\">insert ↔ (equiv) at cursor") ; 
      iffButton.setBackground(shadeColor) ; 
      iffButton.addActionListener(commandActivator) ; 
      iffButton.setActionCommand("iff") ;
      toolbar.add(iffButton) ; 

      //toolbar.add(new JLabel("   ")) ;       

      allButton = new JButton("∀") ; 
      allButton.setFont(bfont) ;  
      allButton.createToolTip() ; 
      allButton.setToolTipText("<html><font size=\"+2\">insert ∀ (for all) at cursor") ; 
      allButton.setBackground(shadeColor) ; 
      allButton.addActionListener(commandActivator) ; 
      allButton.setActionCommand("all") ;
      toolbar.add(allButton) ; 
      /////
      someButton = new JButton("∃") ; 
      someButton.setFont(bfont) ;  
      someButton.createToolTip() ; 
      someButton.setToolTipText("<html><font size=\"+2\">insert ∃ (there exists) at cursor") ; 
      someButton.setBackground(shadeColor) ; 
      someButton.addActionListener(commandActivator) ; 
      someButton.setActionCommand("some") ;
      toolbar.add(someButton) ; 

      //toolbar.add(new JLabel("   ")) ;       

      topButton = new JButton("⊤") ; 
      topButton.setFont(bfont) ;  
      topButton.createToolTip() ; 
      topButton.setToolTipText("<html><font size=\"+2\">insert ⊤ (top) at cursor") ; 
      topButton.setBackground(shadeColor) ; 
      topButton.addActionListener(commandActivator) ; 
      topButton.setActionCommand("top") ;
      toolbar.add(topButton) ; 

      bottomButton = new JButton("⊥") ; 
      bottomButton.setFont(bfont) ;  
      bottomButton.createToolTip() ; 
      bottomButton.setToolTipText("<html><font size=\"+2\">insert ⊥ (bottom) at cursor") ; 
      bottomButton.setBackground(shadeColor) ; 
      bottomButton.addActionListener(commandActivator) ; 
      bottomButton.setActionCommand("bottom") ;
      toolbar.add(bottomButton) ; 

      toolbar.add(new JLabel("   ")) ;       

      intersectButton = new JButton("∩") ; 
      intersectButton.setFont(bfont) ;  
      intersectButton.createToolTip() ; 
      intersectButton.setToolTipText("<html><font size=\"+2\">insert ∩ (intersect) at cursor") ; 
      intersectButton.setBackground(shadeColor) ; 
      intersectButton.addActionListener(commandActivator) ; 
      intersectButton.setActionCommand("intersect") ;
      toolbar.add(intersectButton) ; 

      unionButton = new JButton("∪") ; 
      unionButton.setFont(bfont) ;  
      unionButton.createToolTip() ; 
      unionButton.setToolTipText("<html><font size=\"+2\">insert ∪ (union) at cursor") ; 
      unionButton.setBackground(shadeColor) ; 
      unionButton.addActionListener(commandActivator) ; 
      unionButton.setActionCommand("union") ;
      toolbar.add(unionButton) ; 

      memberButton = new JButton("∈") ; 
      memberButton.setFont(bfont) ;  
      memberButton.createToolTip() ; 
      memberButton.setToolTipText("<html><font size=\"+2\">insert ∈ (member) at cursor") ; 
      memberButton.setBackground(shadeColor) ; 
      memberButton.addActionListener(commandActivator) ; 
      memberButton.setActionCommand("member") ;
      toolbar.add(memberButton) ; 

      emptyButton = new JButton("∅") ; 
      emptyButton.setFont(bfont) ;  
      emptyButton.createToolTip() ; 
      emptyButton.setToolTipText("<html><font size=\"+2\">insert ∅ (empty) at cursor") ; 
      emptyButton.setBackground(shadeColor) ; 
      emptyButton.addActionListener(commandActivator) ; 
      emptyButton.setActionCommand("empty") ;
      toolbar.add(emptyButton) ; 

      toolbar.add(new JLabel("   ")) ;       

      lambdaButton = new JButton("λ") ; 
      lambdaButton.setFont(bfont) ;  
      lambdaButton.createToolTip() ; 
      lambdaButton.setToolTipText("<html><font size=\"+2\">insert λ (lambda) at cursor") ; 
      lambdaButton.setBackground(shadeColor) ; 
      lambdaButton.addActionListener(commandActivator) ; 
      lambdaButton.setActionCommand("lambda") ;
      toolbar.add(lambdaButton) ; 

      piButton = new JButton("Π") ; 
      piButton.setFont(bfont) ;  
      piButton.createToolTip() ; 
      piButton.setToolTipText("<html><font size=\"+2\">insert Π (Pi) at cursor") ; 
      piButton.setBackground(shadeColor) ; 
      piButton.addActionListener(commandActivator) ; 
      piButton.setActionCommand("pi") ;
      toolbar.add(piButton) ; 

      sigmaButton = new JButton("Σ") ; 
      sigmaButton.setFont(bfont) ;  
      sigmaButton.createToolTip() ; 
      sigmaButton.setToolTipText("<html><font size=\"+2\">insert Σ (Sigma) at cursor") ; 
      sigmaButton.setBackground(shadeColor) ; 
      sigmaButton.addActionListener(commandActivator) ; 
      sigmaButton.setActionCommand("sigma") ;
      toolbar.add(sigmaButton) ; 

      toolbar.add(new JLabel("   ")) ;       

      possibleButton = new JButton("◇") ; 
      possibleButton.setFont(bfont) ;  
      possibleButton.createToolTip() ; 
      possibleButton.setToolTipText("<html><font size=\"+2\">insert ◇ (possibly) at cursor") ; 
      possibleButton.setBackground(shadeColor) ; 
      possibleButton.addActionListener(commandActivator) ; 
      possibleButton.setActionCommand("possible") ;
      toolbar.add(possibleButton) ; 

      necessaryButton = new JButton("□") ; 
      necessaryButton.setFont(bfont) ;  
      necessaryButton.createToolTip() ; 
      necessaryButton.setToolTipText("<html><font size=\"+2\">insert □ (necessary) at cursor") ; 
      necessaryButton.setBackground(shadeColor) ; 
      necessaryButton.addActionListener(commandActivator) ; 
      necessaryButton.setActionCommand("necessary") ;
      toolbar.add(necessaryButton) ; 

/////////////////////////////////////////////////////////////////



*/
