package sam.machine.engine ;  

import sam.machine.lang.* ; 
import sam.util.* ; 
import java.util.* ; 
import java.util.concurrent.* ; 

/** 
  *  InferenceManager 
  *  @version 4/14/2020 (very preliminary)
  */
public class InferenceManager implements Runnable {  
   // essential inference structural components
   public Theory theory ;     // sam.machine.lang.Theory
   protected ExecutorService executor ;  // the prover
   protected  ArrayList<Functor> branch ;  // where the facts are
   protected ArrayList<ActiveInference> activeTheory ;   
   // fluents, timely
   public int complexity ;       // how complex?
   public boolean log ;          // construct tree?
   public int depthLimit ;       // if restricted
   public Object tree ;          // logged search tree 
   public RoundRobin queue ;     // colog queueing control
   private volatile boolean exit ;  // exit flag for run()

   public InferenceManager(Theory theory, int dlimit) {  
      this.theory = theory ;
      this.depthLimit = dlimit ; 
      this.branch = new ArrayList<Functor>(depthLimit) ; 
      this.executor =                  
            Executors.newFixedThreadPool​(theory.size()) ; 
      this.activeTheory = new ArrayList<ActiveInference>(theory.size()) ;
      Iterator it = theory.iterator() ; 
      int index = 0 ;   
      while (it.hasNext())  {  // build activeTheory
         Inference next = (Inference)it.next() ; 
         if (next instanceof Rule) { 
            if (((Rule)next).existential>0)
               activeTheory.add(new ActiveExistentialRule((Rule)next,this,index)) ;
            else
               activeTheory.add(new ActiveStagedRule((Rule)next,this,index)) ;
         }
         else  activeTheory.add(new ActiveRewrite((Rewrite)next,this,index)) ; 
         index++ ;
      }
   } 

   /**
     *  Run stage inference until branch finishes.
     *  Switch to next branch.
     *  Continue
      */   
   @Override
   public void run() {
      while (!exit) { 
         // do stages until goal of false
         // switch branch if any waiting 
         // continue stages in branch
      }
   }


   /**
     *  Stopping with message.
      */   
   public void tellStop() { 
      this.exit = true ;
   }
   public String getStopStatis() {
      return "Inference Manager stopped\n" ;
   }

} // end  InferenceManager

/*  
Current code does not address issue of
queueing existential rules.
Perhaps this version will stage a one-shot 
for each erule.  
*/   








